
	.include	nenetto4.mac

A_dma_ch2	equ	$e84080

* $ecc091.b	#%0000_0000
*		  ^				1
*		   ^				INPUT SELECT  0:optical / 1:corexial
*		    ^^				CLOCK SELECT  00: BCKex / 01-11: BCKint
*		       ^^			PANPOT RG,LG
*		         ^			STEREO/MONO
*		          ^			OUT/IN

* $ecc0a1.b	#%0000_0000
*		  ^				reserved
*		   ^				input select
*		    ^^				clock select
*		       ^^^			data frequency
*		          ^			PLL error


wait_LRCK	macro
		
		movea.l	#A_dma_ch2,a0
	@@:	btst.b	#0,(a0)				* dmac ch2 PCL		rec
		beq	@b				* wait 'R'>'L' clock	tȂ̂
	@@:	btst.b	#0,(a0)							
		bne	@b				* wait 'L'>'R' clock	
		
		endm

wait_LRCK2	macro
		
		movea.l	#A_dma_ch2,a0
	@@:	btst.b	#0,(a0)				* dmac ch2 PCL
		bne	@b				* wait 'L'>'R' clock
	@@:	btst.b	#0,(a0)				
		beq	@b				* wait 'R'>'L' clock
		
		endm



start:
	push	a0-a1
	super	P_ussp
	pop	a0-a1
	
	lea.l	$10(a0),a0
	move.l	a0,P_prog
	suba.l	a0,a1
	pea.l	(a1)
	pea.l	(a0)
	DOS	_SETBLOCK
	addq.l	#8,sp
	
	 bsr	_sw_check
	 bsr	_board_check
	 bsr	_unit_init
	 bsr	_file_create
	 bsr	_malloc
	 bsr	_vdisp_int_set
	 bsr	_unit_init2
	 bsr	_init_dmac
	 bsr	_set_dmac2
	 bsr	_wait
	 bsr	_start_dmac
	print	M_write(pc)
	
main_loop:	 bsr	_write
		 bsr	_req_check
		tst.w	F_esc_req2
		bne	@f
		tst.w	F_esc_req
		beq	main_loop
	
	 bsr	_write2
	
@@:	 bsr	_exit_init
	print	M_complete(pc)
	DOS	_EXIT

D_buff_blk_num:		dc.l	64		* mۊ] block 
D_total_blk:		dc.w	0		*  BTC 
D_btc_point:		dc.w	0		* ȑO BTC
D_buff_blk:		dc.w	0		* 1page  BTC
D_1page_size:		dc.l	0		* 1page  obt@

D_seek_point:		dc.l	0		* ݂ file seek ʒu
F_buff_page:		dc.w	0		* page0=0 ; page1=-1
F_file_write_req:	dc.w	0		* file write v
F_esc_req:		dc.w	0		* program exit v
F_esc_req2:		dc.w	0		* program exit v (error)
D_dmac_cpr:		dc.b	0,0,0,0		* dmac CPR register

M_write2:		dc.b	cr,lf,'Writing rest...',cr,lf,0
M_write:		dc.b	'Writing...',0
M_writing:		dc.b	'.',0
M_waiting_data:		dc.b	'Now waiting data...',cr,lf,0
M_waiting_key:		dc.b	'Push space key to start...',cr,lf,0
M_recording:		dc.b	'Recording start !',cr,lf,0

.even


*--------------------------------------------------------------------------------------
_req_check
	move.w	D_total_blk,d0
	sub.w	A_dma_ch2+$1a,d0		* BTC
	move.w	D_btc_point,d1
	sub.w	d1,d0
*	sub.w	#1,d0
*	bmi	@f
	cmp.w	D_buff_blk,d0
	bcc	@@f
@@:	clr.w	F_file_write_req
	rts

@@:	move.w	#1,F_file_write_req
	move.w	D_buff_blk,d0
	add.w	d0,D_btc_point
	rts

*--------------------------------------------------------------------------------------


*--------------------------------------------------------------------------------------
_write:
	tst.w	F_file_write_req
	beq	_write_end
	
	print	M_writing(pc)
	
	clr.w	F_file_write_req
	move.l	D_1page_size,d2
	
	clr.w	-(sp)
	move.l	D_seek_point,-(sp)
	move.w	D_f_handl,-(sp)
	DOS	_SEEK			* seek
	addq.l	#8,sp
	
	movea.l	P_buff,a0
	tst.w	F_buff_page
	beq	@f
	adda.l	d2,a0
@@:	not.w	F_buff_page
	
	move.l	d2,-(sp)
	move.l	a0,-(sp)
	move.w	D_f_handl,-(sp)
	DOS	_WRITE			* write
	lea.l	10(sp),sp
	cmp.l	d0,d2
	bne	_write_err
	
	add.l	d2,D_seek_point
_write_end:
	rts

_write_err:
	move.w	#1,F_esc_req2
	rts
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_write2:
	print	M_write2(pc)
	
	clr.w	-(sp)
	move.l	D_seek_point,-(sp)
	move.w	D_f_handl,-(sp)
	DOS	_SEEK			* seek
	addq.l	#8,sp
	
	movea.l	P_buff,a0
	tst.w	F_buff_page
	beq	@f
	adda.l	D_1page_size,a0
	@@:
	move.l	A_dma_ch2+$c,d0		* MAR
	sub.l	a0,d0
	
	move.l	d0,-(sp)
	move.l	a0,-(sp)
	move.w	D_f_handl,-(sp)
	DOS	_WRITE			* write
	lea.l	10(sp),sp
	
	rts
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_exit_init:
	 bsr	_vdisp_int_reset
	
	move.l	P_prog,-(sp)
	DOS	_MFREE2
	addq.l	#4,sp
	move.l	P_buff,-(sp)
	DOS	_MFREE2
	addq.l	#4,sp
	
	move.w	D_f_handl,-(sp)
	DOS	_CLOSE			* close
	addq.l	#2,sp
	
	rts
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_wait:
	tst.w	F_keywait
	beq	_wait_trigger

	print	M_waiting_key(pc)
	@@:	tst.w	F_esc_req
		bne	_cancel_start
		btst	#5,$806.w
		beq	@b
	bra	@@f

	_wait_trigger:				* ̌o
	print	M_waiting_data(pc)
	movea.l	#$ecc080,a0			* L ch
	@@:	tst.w	F_esc_req
		bne	_cancel_start
		tst.w	(a0)
		beq	@b

	@@:
	print	M_recording(pc)
	move.w	#1,F_on_recording
	rts

_cancel_start:
	print	M_cancel(pc)
	 bsr	_exit_init
	DOS	_EXIT
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_key_check:
	tst.w	F_keywait
	beq	@f
	tst.w	F_on_recording
	beq	@f
	btst.b	#5,$806.w			* SPACE ?
	bne	@@f
	clr.w	F_on_recording

@@:	btst.b	#5,$806.w			* SPACE ?
	bne	@@@f

@@:	btst.b	#1,$800.w			* ESC ?
	bne	@@f
	btst.b	#1,$80e.w			* CTRL ?
	beq	@f
	btst.b	#0,$804.w			* 'D' ?
	bne	@@f
@@:	rts

@@:	move.w	#1,F_esc_req
	move.b	#%0001_0000,A_dma_ch2+7		* DMA stop
	rts
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
V_vdisp_int:
		di		*	
		push	d0-d7/a0-a6
		
		move.w	#1,F_int_running
		 bsr	_key_check
		
		pop	d0-d7/a0-a6
		ei		*	
		rte
*--------------------------------------------------------------------------------------


*--------------------------------------------------------------------------------------
_vdisp_int_set:
	di			*	
	
	moveq.l	#1,d1			* 30 int/sec
	lea.l	V_vdisp_int(pc),a1
	IOCS	_VDISPST
	tst.l	d0
	bne	_int_set_err
	
	ei			*	
	
@@:	tst.w	F_int_running
	beq	@b
	rts

_int_set_err:
	b_print	M_int_set_err
	move.w	#1,-(sp)
	DOS	_EXIT2

*-------------------------------------------------------------------------------
_vdisp_int_reset:
	di			*	
	
	suba.l	a1,a1
	IOCS	_VDISPST
	
	ei			*	
	rts
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_unit_init:				* INPUT SELECT ̂܂܂ INPUT[h
		move.b	$ecc0a1,d0
		and.b	#%0100_0000,d0
		or.b	#%0000_1110,d0
		move.b	d0,$ecc091
	rts
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_unit_init2:
		move.b	#%1000_1110,d0
*			  ^			1
*			   ^			INPUT SELECT  0:optical / 1:corexial
*			    ^^			CLOCK SELECT  00: BCKex / 01-11: BCKint
*			       ^^		PANPOT RG,LG
*			         ^		STEREO/MONO
*			          ^		OUT/IN
		tst.w	F_stereo
		bne	@f
		move.b	#%1000_1100,d0
	@@:	tst.w	D_input
		beq	@f
		bset	#6,d0
	@@:	move.b	d0,$ecc091
		vwait	6
		btst	#0,$ecc0a1
		bne	_no_input
		move.w	#0,$ecc080
	rts

_no_input:
	print	M_no_input(pc)
	 bsr	_exit_init
	DOS	_EXIT
*--------------------------------------------------------------------------------------


*--------------------------------------------------------------------------------------
_start_dmac:
	wait_LRCK2
	move.b	#%1000_1000,A_dma_ch2+7			* DMA start
	rts
*--------------------------------------------------------------------------------------


*--------------------------------------------------------------------------------------
_set_dmac2:
		move.l	D_f_size,d0
		lsr.l	#1,d0
		move.l	#$10000,d2
		movea.l	#$ecc080,a0
		move.l	a0,A_dma_ch2+$14	* DAR
		
		move.l	#$8000,d1
		divu	d1,d0
		move.w	d0,D_total_blk
		move.w	d0,A_dma_ch2+$1a	* BTC
		movea.l	P_chain_tbl(pc),a0
		move.l	a0,A_dma_ch2+$1c	* BAR
		movea.l	P_buff,a1
		move.w	D_buff_blk,d6
		lsl.w	#1,d6
		clr.w	d7
		subq.l	#1,d0
		_mk_chain_tbl_2:
			move.l	a1,(a0)+
			move.w	d1,(a0)+
			adda.l	d2,a1
			addq.w	#1,d7
			cmp.w	d6,d7
			bne	@f
			movea.l	P_buff,a1
			clr.w	d7
			@@:
		dbra.w	d0,_mk_chain_tbl_2
	rts
*--------------------------------------------------------------------------------------


*--------------------------------------------------------------------------------------
_init_dmac:
		movea.l	#A_dma_ch2,a0
		move.b	#%1111_1111,(a0)		* CSR
		move.b	#%1000_1000,4(a0)		* DCR
		*	  ^^		cycle steal mode
		*	    ^^		68000 device
		*	       ^	16bit port
		*		 ^^	PCL = status
		
		move.b	#%1001_1010,5(a0)		* OCR
		*	  ^		dev > mem	* 
		*	   ^		DONE no use
		*	    ^^		operand 16bit	* 
		*	       ^^	aray chain	
		*		 ^^	ext REQ
		
		move.b	#%0000_0100,6(a0)		* SCR
		*	       ^^	MAC /memory count inc.
		*		 ^^	DAC /device count fix
		move.b	#%0000_0000,7(a0)		* CCR
		*	  ^		STR /1:start
		*	   ^		CNT /1:continue use
		*	    ^		HLT /1:halt
		*	     ^		SAB /1:soft abort
		*	       ^	INT /1:int disenable	* 
		movea.l	#$e84000,a0
		lea.l	D_dmac_cpr,a1
		move.b	$2d(a0),(a1)+			* CPR
		move.b	#%000000_11,$2d(a0)
		*		 ^^	ch0 = priority 3	FD
		move.b	$40+$2d(a0),(a1)+
		move.b	#%000000_10,$40+$2d(a0)
		*		 ^^	ch1 = priority 2	HD
		move.b	$80+$2d(a0),(a1)+
		move.b	#%000000_00,$80+$2d(a0)
		*		 ^^	ch2 = priority 0	PCM
		move.b	$c0+$2d(a0),(a1)+
		move.b	#%000000_01,$c0+$2d(a0)
		*		 ^^	ch3 = priority 1	ADPCM
	rts


*--------------------------------------------------------------------------------------
_file_create:
	move.w	#%10_0000,-(sp)
	move.l	P_fname,-(sp)
	DOS	_CREATE			* file open
	addq.l	#6,sp
	tst.l	d0
	bmi	file_open_err
	move.w	d0,D_f_handl
	rts
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_re_malloc:
	move.l	D_buff_blk_num,d0
	lsr.l	#1,d0
	move.l	d0,D_buff_blk_num

_malloc:
	move.l	#121*1024*1024,D_f_size
	
	move.l	D_buff_blk_num,d0
****	tst.w	F_stereo
****	beq	@f
****	lsr.l	#1,d0
@@:	move.w	d0,D_buff_blk
	beq	malloc_err
	
	swap	d0				* *$8000 *2
****	tst.w	F_stereo
****	beq	@f
****	lsl.l	#1,d0
@@:	move.l	d0,D_1page_size
	
	lsl.l	#1,d0				* 2 page
	move.l	d0,-(sp)
	move.w	#0,-(sp)
	DOS	_MALLOC2		* pcm data malloc
	addq.l	#6,sp
	tst.l	d0
	bmi	_re_malloc
	move.l	d0,P_buff
	
	move.l	D_f_size,d0
	lsr.l	#1,d0
	move.l	#$8000,d1
****	tst.w	F_stereo
****	beq	@f
****	lsr.l	#1,d0
@@:	divu	d1,d0
	andi.l	#$ffff,d0
	mulu	#6,d0
	move.l	d0,-(sp)
	move.w	#0,-(sp)
	DOS	_MALLOC2		* chain table malloc
	addq.l	#6,sp
	tst.l	d0
	bmi	malloc_err
	move.l	d0,P_chain_tbl
	
	rts

malloc_err:
	print	M_malloc_err(pc)
	bra	@f

file_open_err:
	print	M_fopen_err(pc)
	bra	@f

file_write_err:
	print	M_fwrite_err(pc)
@@:	move.w	#1,-(sp)
	DOS	_EXIT2
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_sw_check:
	tst.b	(a2)+
	beq.w	_sw_ck_err
	
	_sw_ck_loop:
	move.b	(a2)+,d0
	cmp.b	#' ',d0
	beq.w	_sw_ck_loop
	cmp.b	#'-',d0
	bne.w	_sw_ck_end
	
	move.b	(a2)+,d0
	ori.b	#%0110_0000,d0
	cmp.b	#'c',d0
	beq	_sw_c
	cmp.b	#'k',d0
	beq	_sw_k
	cmp.b	#'m',d0
	beq	_sw_m
	bra	_sw_ck_err

_sw_c:	move.w	#1,D_input
	tst.b	1(a2)
	beq	_sw_ck_err
	bra	_sw_ck_loop

_sw_k:	move.w	#1,F_keywait
	tst.b	1(a2)
	beq	_sw_ck_err
	bra	_sw_ck_loop

_sw_m:	clr.w	F_stereo
	tst.b	1(a2)
	beq	_sw_ck_err
	bra	_sw_ck_loop

_sw_ck_end:
	subq.l	#1,a2
	move.l	a2,P_fname
	rts

_sw_ck_err:
	print	M_usage(pc)
	move.w	#2,-(sp)
	DOS	_EXIT2
*--------------------------------------------------------------------------------------

*--------------------------------------------------------------------------------------
_board_check:
	push	a0-a6
	 bsr	@@f
	bne	@f
	pop	a0-a6
	rts

@@:	print	M_board_err(pc)
	move.w	#1,-(sp)
	DOS	_EXIT2

@@:	clr.l	d0		* ׂ!i
	move.l	a7,a6
	lea.l	@f(pc),a1
	move.l	8.w,a2
	move.l	a1,8.w
	move.b	$ecc080,d0
	cmp.l	#'saki',d0
	beq	@f
	move.l	a2,8.w
	moveq.l	#0,d0
	rts

@@:	move.l	a6,a7
	move.l	a2,8.w
	move.l	#'saki',d0
	rts
*--------------------------------------------------------------------------------------


*--------------------------------------------------------------------------------------
.data
P_ussp:		dc.l	0
P_fname:	dc.l	0
P_dma_end_org:	dc.l	0
P_dma_err_org:	dc.l	0
P_prog:		dc.l	0
P_buff:		dc.l	0
P_chain_tbl:	dc.l	0
D_f_size:	dc.l	0
D_f_handl:	dc.w	0
D_input:	dc.w	0
F_keywait:	dc.w	0
F_loop:		dc.w	0
F_stereo:	dc.w	1
F_triga:	dc.w	0
F_int_running:	dc.w	0
F_on_recording:	dc.w	0

M_usage:	dc.b	'Usage: rec16 [option] filename',cr,lf
		dc.b	'Options:				',cr,lf
		dc.b	'	 -m    for monoral data		',cr,lf
		dc.b	'	 -c    corexial input		',cr,lf
		dc.b	'	 -k    wait space key		',cr,lf
		dc.b	cr,lf
		dc.b	"16Bit PCM recorder for 'Mercury-Unit V2'.  / "
		dc.b	'Ver 0.35 / (C)Tonkyun',cr,lf
		dc.b	0

M_malloc_err:	dc.b	'No memory!',cr,lf,0
M_fopen_err:	dc.b	'File create error!',cr,lf,0
M_fwrite_err:	dc.b	'File write error!',cr,lf,0
M_board_err:	dc.b	'Mercury-Unit is not exist!',cr,lf,0
M_int_set_err:	dc.b	'Vdisp int set error!',cr,lf,0
M_complete:	dc.b	'Ok.',cr,lf,0
M_cancel:	dc.b	'Canceled !',cr,lf,0
M_no_input:	dc.b	'No digital input !',cr,lf,0
.even
endadd:
*--------------------------------------------------------------------------------------
