/*
	vc - VENUS-X 2hd-CACHE controller  version 0.10

		Copyright (C)1998 Tachibana Eririn

*/


#include <stdio.h>
#include <string.h>
#include <sys/dos.h>


/* VENUS-X 2nd-CACHE register */
#define	VXREG	(unsigned long*)0x00ecf000


/*
	VENUS-X  2nd-CACHE Lɂ.
*/
static void
cache_on (void)
{
   int ssp = _dos_super (0);

   *VXREG = 0x80;			/* *VXREG |= 0x80; */

   (void) _dos_super (ssp);
}

/*
	VENUS-X  2nd-CACHE 𖳌ɂ.
*/
static void
cache_off (void)
{
   int ssp = _dos_super (0);

   *VXREG = 0x00;			/* *VXREG &= 0x7f; */

   (void) _dos_super (ssp);
}


/*
	VENUS-X  2nd-CACHE ̏Ԃ\.
*/
static void
print_status (void)
{
    int ssp = _dos_super (0);

    int stat = *VXREG;

    (void) _dos_super (ssp);

    (void) printf ("VENUS-X 2nd-CACHE %s!!\n", (stat & 0x80) ? "ON" : "OFF");
}


/*
	VENUS-X Ă邩ׂ.
	ȃ`FbNł͂Ȃ.
	Ԓl 0 Ȃ瑕Ă.
*/
static int
is_exist_venus_x (void)
{
    register int reg_d0 __asm ("d0");

    __asm __volatile (
	"move	#4,-(sp)\n\t"
	"pea	(-4,sp)\n\t"
	"move.l	#$00ecf000,-(sp)\n\t"
	".dc	$fff7\n\t"		/* DOS _BUS_ERR */
	"lea	(10,sp),sp"
	: "=d" (reg_d0)
	: /* no input */
    );

    return reg_d0;
}


/*
	gp@\.
*/
static void
print_usage (void)
{
    printf (
	"vc - VENUS-X 2hd-CACHE controller  version 0.10\n"
	"\tCopyright (C)1998 Tachibana Eririn\n"
	"usage: vc [option] [on|off]\n"
	"option:\n"
	"\t-q\tquiet operation\n"
    );
}

/*
	o[W\.
*/
static void
print_version (void)
{
    printf ("vc version 0.10\n");
}


typedef enum { PRINT, ON, OFF } ACTION;

/*
	C
*/
int
main (int argc, char* argv[])
{
    int quiet_flag = 0;
    ACTION act = PRINT;
    int i;

    /*  */
    for (i = 1; i < argc; i++) {
	char* arg = argv[i];

	if (*arg == (char)'-') {
	    /* IvV̏ */
	    arg++;
	    while (*arg) {
		switch (*arg++) {
		case '-':
		    if (strcmp (arg, "quiet") == 0) {
			arg += strlen (arg);	/* point NUL */
		case 'q':
			quiet_flag = 1;
			break;
		    } else if (strcmp (arg, "version") == 0) {
		case 'v':
			print_version ();
			return 0;
			/* NOT REACHED */
		    } else if (strcmp (arg, "help") == 0) {
		case '?':
		case 'h':
			print_usage ();
			return 0;
			/* NOT REACHED */
		    } else {
		default:
			print_usage ();
			return 1;
			/* NOT REACHED */
		    }
		}
	    }
	} else {
	    /* on ܂ off */
	    if (strcmp (arg, "on") == 0)
		act = ON;
	    else if (strcmp (arg, "off") == 0)
		act = OFF;
	    else {
			print_usage ();
			return 1;
			/* NOT REACHED */
	    }
	}
    }

    /* VENUS-X ̑`FbN */
    if (is_exist_venus_x () != 0) {
	printf ("VENUS-X Ă܂!!\n");
	return 1;
    }

    /* on ܂ off */
    if (act == ON)
	cache_on ();
    else if (act == OFF)
	cache_off ();

    /* ݂̏Ԃ\ */
    if (quiet_flag == 0)
	print_status ();

    return 0;
}

/* EOF */
