******************************************************************
**								**
**	VENUS-X Cache Control tool	ver0.21			**
**						by ӂȂۂ	**
**								**
**					since 1998 Mar 7	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	CONST.H

VENUS_SRAM_ADDRESS	equ	$00ed_0094	* vx.r


	.cpu	68030

	.text
	.even


	lea.l	MYSP(pc),sp			*X^bN|Cgw̃AhX

	lea.l	$00ec_f000,a4			*VENUS CCR
	moveq.l	#0,d5				*Mach2
	moveq.l	#0,d4				*SRAM
	moveq.l	#0,d3				*Massage


	clr.l	-(sp)
	DOS	_SUPER				* X[p[oCU[h
	addq.l	#4,sp				*
	move.l	d0,a5				*a5:ssp

**********************************************************
**			Board Check			**
**********************************************************

VENUS_CHECK::
	lea.l	$00e0_0000,a0
	move.l	(a0),d6

	move.w	#4,-(sp)				*TCY
	move.l	a0,-(sp)		*TEXT VRAM	
	move.l	#$00ec_f004,-(sp)	*VENUS-X ID #1	ǂݍ
	DOS	_BUS_ERR		*$fff7
	lea	10(sp),sp

	move.l	d6,(a0)

		tst.l	d0
		bne	NO_VENUS_X		*

	move.l	$4(a4),d0
	cmpi.b	#'V',d0
	bne	NO_VENUS_X

	move.l	(a0),d6

	move.w	#4,-(sp)				*TCY
	move.l	a0,-(sp)		*TEXT VRAM	
	move.l	#$00ec_f008,-(sp)	*VENUS-X ID #1	ǂݍ
	DOS	_BUS_ERR		*$fff7
	lea	10(sp),sp

	move.l	d6,(a0)

		tst.l	d0
		bne	NO_VENUS_X		*

	move.l	$8(a4),d0
	cmpi.b	#'X',d0
	bne	NO_VENUS_X

	move.l	(a4),d7				*d7

**********************************************************
**		Comand Line Option Check		**
**********************************************************

	addq.l	#1,a2

C_CHECK::
	bsr	SKIPSP				*
	tst.b	(a2)				*
	beq	STATUS_CHECK

	cmpi.b	#'-',(a2)
	beq	OP_CHECK
	cmpi.b	#'/',(a2)
	beq	OP_CHECK

	move.b	(a2)+,d0
	bsr	TOUPPER				*啶ɕϊĂ
	cmpi.b	#'O',d0
	bne	USAGE

	move.b	(a2)+,d0
	bsr	TOUPPER
	cmpi.b	#'N',d0
	beq	CACHE_ON
	cmpi.b	#'F',d0
	bne	USAGE

	move.b	(a2)+,d0
	bsr	TOUPPER
	cmpi.b	#'F',d0
	beq	CACHE_OFF

	bra	USAGE

OP_CHECK::
	addq.l	#1,a2				*"/""-"̕a2i߂Ă
	move.b	(a2)+,d0			*ꕶo
	bsr	TOUPPER				*啶ɕϊĂ

	cmpi.b	#"O",d0
	beq	CACHE_ON
	cmpi.b	#"F",d0
	beq	CACHE_OFF
	cmpi.b	#"W",d0
	beq	WAIT_CHECK

	cmpi.b	#"S",d0
	beq	CACHE_SAVE_SET
	cmpi.b	#"L",d0
	beq	CACHE_LOAD_SET

	cmpi.b	#"N",d0
	beq	NO_MESSAGE

	cmpi.b	#"T",d0
	beq	TAG_DATA_SET

	bra	USAGE

**********************************************************
**			Value Set			**
**********************************************************
CACHE_ON::
	ori.b	#%1000_0000,d7
	bra	C_CHECK

CACHE_OFF::
	andi.b	#%0111_1111,d7
	bra	C_CHECK

WAIT_CHECK::
	move.b	(a2)+,d0
	beq	STATUS_CHECK
	cmpi.b	#'0',d0
	beq	DATA_WRITE_WAIT_OFF
	cmpi.b	#'1',d0
	beq	DATA_WRITE_WAIT_ON
	cmpi.b	#SPACE,d0
	beq	C_CHECK
	cmpi.b	#TAB,d0
	beq	C_CHECK
	bra	WAIT_OPTION_ERROR

DATA_WRITE_WAIT_OFF::
	ori.b	#%0000_1000,d7
	bra	@F

DATA_WRITE_WAIT_ON::
	andi.b	#%1111_0111,d7
@@:
	move.b	(a2)+,d0
	beq	STATUS_CHECK
	cmpi.b	#'0',d0
	beq	DRAM_READ_WAIT_OFF
	cmpi.b	#'1',d0
	beq	DRAM_READ_WAIT_ON
	cmpi.b	#SPACE,d0
	beq	C_CHECK
	cmpi.b	#TAB,d0
	beq	C_CHECK
	bra	WAIT_OPTION_ERROR

DRAM_READ_WAIT_OFF::
	ori.b	#%0000_0100,d7
	bra	@F

DRAM_READ_WAIT_ON::
	andi.b	#%1111_1011,d7
@@:
	move.b	(a2)+,d0
	beq	STATUS_CHECK
	cmpi.b	#'0',d0
	beq	CACHE_WAIT_ON
	cmpi.b	#'1',d0
	beq	CACHE_WAIT_OFF
	cmpi.b	#SPACE,d0
	beq	C_CHECK
	cmpi.b	#TAB,d0
	beq	C_CHECK
	bra	WAIT_OPTION_ERROR

CACHE_WAIT_OFF::
	ori.b	#%0000_0010,d7
	bra	C_CHECK

CACHE_WAIT_ON::
	andi.b	#%1111_1101,d7
	bra	C_CHECK

CACHE_SAVE_SET::
	moveq.l	#1,d4
	bra	C_CHECK

CACHE_LOAD_SET::
	moveq.l	#2,d4
	bra	C_CHECK

NO_MESSAGE::
	moveq.l	#1,d3
	bra	C_CHECK

TAG_DATA_SET::

	lea.l	$00ea_00e0,a0
	lea.l	$00e0_0000,a1

	move.l	(a1),d6

	move.w	#4,-(sp)				*TCY
	move.l	a1,-(sp)		*TEXT VRAM	
	move.l	a0,-(sp)		*Mach2 ROM	ǂݍ
	DOS	_BUS_ERR		*$fff7
	lea	10(sp),sp

	move.l	d6,(a1)

		tst.l	d0
		bne	NO_Mach2		*Mach2

	move.l	(a0),d5				*d5 'BIOS'

NO_Mach2::
	move.b	(a2)+,d0
	cmpi.b	#"0",d0
	beq	TAG_FLUSH
	cmpi.b	#"1",d0
	beq	TAG_KEEP
	cmpi.b	#"2",d0				*force
	beq	FORCE_TAG_KEEP
	bra	TAG_DATA_SET_ERROR

TAG_KEEP::
	cmpi.l	#'BIOS',d5
	beq	EXIST_Mach2

FORCE_TAG_KEEP::
	ori.b	#%0000_0001,d7
	bra	C_CHECK

EXIST_Mach2::
	pea.l	EXIST_Mach2_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

TAG_FLUSH::
	andi.b	#%1111_1110,d7
	bra	C_CHECK

**********************************************************
**			Status Check			**
**********************************************************

STATUS_CHECK::
	move.l	d7,(a4)

	tst.w	d3
	bne	NO_STATUS_MASSAGE

*********************************************************
*	bit 7 : Cache Enable / Disable.			*
*		(W)	1 : Enable, 0 : Disable		*
*		(R)	1 : Active, 0 : Inactive	*
*********************************************************

	pea.l	CACHE_MODE_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

	lea.l	ENABLE_MES(pc),a1
	lea.l	DISENABLE_MES(pc),a2
	moveq.l	#7,d1
	bsr	REG_CHECK

*****************************************************************
*	$ECF00C : VENUS-X ID #3 ( Read only )			*
*	bit[7:0] = $31, MC68030, Revision.1 --@݂̒l	*
*	         = $4n, MC68040, Revision.n ( Reserved )	*
*	         = $6n, MC68060, Revision.n ( Reserved )	*
*****************************************************************

	move.l	$00EC_F00C,d2

	move.w	d2,d1
	lsr.w	#4,d2
	andi.b	#%0000_1111,d2
	add.b	#$30,d2
	lea.l	MPU(pc),a0			*.r
	move.b	d2,(a0)

	pea.l	MPU_NAME_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

	lea.l	REVISION(pc),a0			*.r
	andi.b	#%0000_1111,d1
	cmpi.b	#9,d1
	bhi	TO_HEX
	add.b	#$30,d1
	move.b	d1,(a0)
	bra	PRINT_REV
TO_HEX::
	add.b	#$57,d1
	move.b	d1,$1(a0)

PRINT_REV::
	pea.l	REVISION_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

*****************************************************************
*	bit 3: DATA Write Access wait. 				*
*	( R/W )	 1 : decrease 1 clock. ( Not recommend. )	*
*		 0 : Normal mode. ( default. )			*
*****************************************************************

	pea.l	DATA_WRITE_ACCESS_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

	lea.l	DECREASE_1_CLOCK_MES(pc),a1
	lea.l	NORMAL_MOCE_MES(pc),a2
	moveq.l	#3,d1
	bsr	REG_CHECK

*****************************************************************
*	bit 2: DRAM Read Access wait.				*
*	( R/W )	1 : decrease 1 clock. ( Not recommend. )	*
*		0 : Normal mode. ( default. )			*
*****************************************************************

	pea.l	DRAM_READ_ACCESS_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

*	lea.l	DECREASE_1_CLOCK_MES(pc),a1
*	lea.l	NORMAL_MOCE_MES(pc),a2
	moveq.l	#2,d1
	bsr	REG_CHECK

*****************************************************************
*	bit 1 : CACHE MEMORY ACCESS WAIT.			*
*	( R/W )	1 : 50MHZ FULL-SPEC MODE.			*
*		0 : WAIT INSERT MODE. ( EG. OVER 50MHZ )	*
*****************************************************************

	pea.l	CACHE_MEMORY_ACCESS_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

	lea.l	FULL_SPEC_MODE_MES(pc),a1
	lea.l	WAIT_INSERT_MODE_MES(pc),a2
	moveq.l	#1,d1
	bsr	REG_CHECK

*****************************************************************
*	bit 0: KEEP TAG DATA.					*
*	( R/W )	1 : YES. ( eg. Internal SCSI )			*
*		0 : NO. Force TAG-flush at BGACK* is asserted. 	*
*		    ( eg.Equipped MACH2 board )			*
*****************************************************************

	pea.l	KEEP_TAG_DATA_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

	lea.l	YES_MES(pc),a1
	lea.l	NO_MES(pc),a2
	moveq.l	#0,d1
	bsr	REG_CHECK

NO_STATUS_MASSAGE::
	move.w	SRAM_TABLE(pc,d4.w*2),d4		*MC68030ȍ~p
	jmp	SRAM_TABLE(pc,d4.w)

SRAM_TABLE::
	.dc.w	END-SRAM_TABLE
	.dc.w	CACHE_SAVE-SRAM_TABLE
	.dc.w	CACHE_LOAD-SRAM_TABLE

**********************************************************
**			SRAM				**
**********************************************************

CACHE_SAVE::
	move.b	#$31,$00e8_e00d		* sram enable

	move.l	(a4),d0
	move.b	d0,VENUS_SRAM_ADDRESS

	move.b	#0,$00e8_e00d		* sram disable

	pea.l	SAVE_SRAM_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

	bra	END

CACHE_LOAD::
	moveq.l	#0,d0
	move.b	VENUS_SRAM_ADDRESS,d0
	move.l	d0,(a4)

	pea.l	LOAD_SRAM_MES(pc)
	DOS	_PRINT
	addq.l	#4,sp

*	bra	END

**********************************************************
**			END				**
**********************************************************

END::
	move.l	a5,-(sp)		*
	DOS	_SUPER			* [U[[h
	addq.l	#4,sp			*

	DOS	_EXIT

**********************************************************
**			ERROR ROUTINE			**
**********************************************************
NO_VENUS_X::
	pea.l	NO_VENUS_X_MES(pc)
	bra	PRINT_MES

WAIT_OPTION_ERROR::
	pea.l	WAIT_OPTION_ERROR_MES(pc)
	bra	PRINT_MES

TAG_DATA_SET_ERROR::
	pea.l	TAG_DATA_SET_ERROR_MES(pc)
	bra	PRINT_MES

USAGE::
	pea.l	USAGE_MES(pc)
PRINT_MES::
	DOS	_PRINT
	addq.l	#4,sp

	bra	END

**********************************************************
**			SUB ROUTINE			**
**********************************************************
**********************************
**	Reg Check		**
**********************************
REG_CHECK::
	btst.l	d1,d7
	beq	REG_ZERO

	move.l	a1,-(sp)
	bra	@F

REG_ZERO::
	move.l	a2,-(sp)
@@:
	DOS	_PRINT
	addq.l	#4,sp

	rts


TOUPPER::
		cmpi.b	#"a",d0			*Ȃ啶
		bcs	TOUPPER0
		cmpi.b	#"z"+1,d0
		bcc	TOUPPER0
		subi.b	#$20,d0
TOUPPER0::
		rts

SKIPSP0::	addq.l	#1,a2
SKIPSP::
		cmpi.b	#SPACE,(a2)		*
		beq	SKIPSP0
		cmpi.b	#TAB,(a2)		*space&tab͔΂
		beq	SKIPSP0
		rts

**********************************************************
**			DATA ARIA			**
**********************************************************
	.data
	.even

TITLE::
	.dc.b	'VENUS-X Cache Control Tool ver0.21',CR,LF
	.dc.b	'		Programed by FunaPon Apr 25 1998',CR,LF
	.dc.b	CR,LF,0
USAGE_MES::
	.dc.b	'usage : vcc.r <OPTION>',CR,LF
	.dc.b	'option: [nothing]: VENUS-X status',CR,LF
	.dc.b	'      : on       : 2nd-Cache ON',CR,LF
	.dc.b	'      : off      : 2nd-Cache OFF',CR,LF
	.dc.b	'      : -n       : NO PRINT',CR,LF
	.dc.b	'      : -w*1*2*3 : Various Wait Insert',CR,LF
	.dc.b	'      :      [*1]: DATA Write Access wait on',CR,LF
	.dc.b	'      :      [*2]: DRAM Read Access wait',CR,LF
	.dc.b	'      :      [*3]: CACHE Memory Access wait',CR,LF
	.dc.b	'      : -t[n]    : KEEP TAG DATA',CR,LF
	.dc.b	'      :       n=0: NO. Force TAG-flush at BGACK* is asserted. ( eg.Equipped MACH2 board )',CR,LF
	.dc.b	'      :       n=1: YES. ( eg. Internal SCSI )',CR,LF
	.dc.b	'      :       n=2: Force NO.',CR,LF
	.dc.b	'      : -s       : SRAM Save',CR,LF
	.dc.b	'      : -l       : SRAM Load',CR,LF,0

WAIT_OPTION_ERROR_MES::	.dc.b	'Wait Option Error! [ex. vcc -w110]',CR,LF,0
TAG_DATA_SET_ERROR_MES::.dc.b	'TAG Data Option Error! [n:0`2]',CR,LF,0
NO_VENUS_X_MES::	.dc.b	'VENUS-X has not installed this X680x0.',CR,LF,0
EXIST_Mach2_MES::	.dc.b	'This X680x0 has equiped with Mach2!',CR,LF
			.dc.b	CR,LF,0
SAVE_SRAM_MES::		.dc.b	CR,LF
			.dc.b	'Cache Status was saved to SRAM($ed0094.b).',CR,LF,0
LOAD_SRAM_MES::		.dc.b	CR,LF
			.dc.b	'Cache Status was loaded from SRAM($ed0094.b).',CR,LF,0

CACHE_MODE_MES::	.dc.b	'Second Cache		: ',0
MPU_NAME_MES::		.dc.b	'Micro Processing Unit	: 680'
MPU:			.dc.b	'30',CR,LF,0
REVISION_MES::		.dc.b	'VENUS-X Revision	: '
REVISION:		.dc.b	'$ ',CR,LF,0
DATA_WRITE_ACCESS_MES::	.dc.b	'DATA  Write  Access wait: ',0
DRAM_READ_ACCESS_MES::	.dc.b	'DRAM  Read   Access wait: ',0
CACHE_MEMORY_ACCESS_MES::.dc.b	'CACHE Memory Access wait: ',0
KEEP_TAG_DATA_MES::	.dc.b	'KEEP TAG DATA		: ',0

ENABLE_MES::		.dc.b	'enable',CR,LF,0
DISENABLE_MES::		.dc.b	'disable',CR,LF,0
DECREASE_1_CLOCK_MES::	.dc.b	'decrease 1 clock',CR,LF,0
NORMAL_MOCE_MES::	.dc.b	'Normal mode',CR,LF,0
FULL_SPEC_MODE_MES::	.dc.b	'50MHz full-spec mode',CR,LF,0
WAIT_INSERT_MODE_MES::	.dc.b	'Wait insert mode',CR,LF,0
YES_MES::		.dc.b	'YES',CR,LF,0
NO_MES::		.dc.b	'NO. Force TAG-flush at BGACK* is asserted.',CR,LF,0

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
