/*
 *  `cobleXg
 *
 */

#include <stdio.h>
#include <stdlib.h>
#define __DOS_INLINE__
#include <sys/dos.h>


volatile unsigned char *ppi_cwr;	/* 8255 Rg[[hWX^ */
volatile unsigned char *opm_regno;	/* OPM WX^ԍݒ背WX^	*/
volatile unsigned char *opm_data;	/* OPM f[^WX^		*/
volatile unsigned char *adpcm_command;	/* ADPCM R}hWX^	*/
volatile unsigned char *adpcm_status;	/* ADPCM Xe[^XWX^	*/
volatile unsigned char *adpcm_data;	/* ADPCM f[^WX^		*/

#define BUFSIZE 0x400
unsigned char pcmbuf[BUFSIZE];


void create_adpcmdata();
void adpcm_outsel();
void adpcm_sample();
void adpcm_clksel();
void adpcm_stop();
void adpcm_start();
void clear_flag();
void write_data (void);

int
main (int argc, char* argv[])
{
    unsigned int    pan, sample, clk;

    pan    = (argc >= 2) ? atoi (argv[1]) : 0;
    sample = (argc >= 3) ? atoi (argv[2]) : 0;
    clk    = (argc >= 4) ? atoi (argv[2]) : 0;

    _dos_super(0);
    ppi_cwr	  = (unsigned char*)0xe9a007;
    opm_regno	  = (unsigned char*)0xe90001;
    opm_data	  = (unsigned char*)0xe90003;
    adpcm_command = (unsigned char*)0xe92001;
    adpcm_status  = (unsigned char*)0xe92001;
    adpcm_data	  = (unsigned char*)0xe92003;

    adpcm_stop ();
    create_adpcmdata (pcmbuf, BUFSIZE);
    adpcm_outsel (pan);		/* Panpot Control */
    adpcm_sample (sample);	/* Sampling rate  */
    adpcm_clksel (clk);		/* ADPCM Clock	  */

    adpcm_start ();
    write_data ();
    adpcm_stop ();

    return 0;
}

void
create_adpcmdata (unsigned char* buf, unsigned int length)
{
    while (length--)
	*buf++ = 0x1f;
}

void
adpcm_outsel (unsigned int sel)
{
    *ppi_cwr = (0 << 1) | ((sel >> 1) & 1);	/* Left  */
    *ppi_cwr = (1 << 1) | ((sel >> 0) & 1);	/* Right */
}

void
adpcm_sample (unsigned int rate)
{
    *ppi_cwr = (2 << 1) | ((rate >> 1) & 1);
    *ppi_cwr = (3 << 1) | ((rate >> 0) & 1);
}

void
adpcm_clksel (unsigned int sel)
{
    *opm_regno = 0x1b;
    *opm_data = (sel & 1) << 7;
}

void
adpcm_stop (void)
{
    *adpcm_command = 0x1;
}

void
adpcm_start (void)
{
    *adpcm_command = 0x2;
}

void
write_data (void)
{
    int i;
    char* p = pcmbuf;
    __volatile unsigned char* req = (unsigned char*)(0xe840c0 + 0x00);

    for (i = BUFSIZE; --i >= 0;) {
	/* PCL  Low ɂȂ̂҂ */
	while (*req & 1)
	    ;
	*adpcm_data = *p++;
	/* PCL  High ɂȂ̂҂ */
	while ((*req & 1) == 0)
	    ;
    }
}

/* EOF */
