/*
 *  `cobleXg
 *
 */

#include <stdio.h>
#include <stdlib.h>
#define __DOS_INLINE__
#include <sys/dos.h>


struct DMAREG {
    unsigned char	csr;
    unsigned char	cer;
    unsigned short	spare1;
    unsigned char	dcr;
    unsigned char	ocr;
    unsigned char	scr;
    unsigned char	ccr;
    unsigned short	spare2;
    unsigned short	mtc;
    unsigned char	*mar;
    unsigned long	spare3;
    unsigned char	*dar;
    unsigned short	spare4;
    unsigned short	btc;
    unsigned char	*bar;
    unsigned long	spare5;
    unsigned char	spare6;
    unsigned char	niv;
    unsigned char	spare7;
    unsigned char	eiv;
    unsigned char	spare8;
    unsigned char	mfc;
    unsigned short	spare9;
    unsigned char	spare10;
    unsigned char	cpr;
    unsigned short	spare11;
    unsigned char	spare12;
    unsigned char	dfc;
    unsigned long	spare13;
    unsigned short	spare14;
    unsigned char	spare15;
    unsigned char	bfc;
    unsigned long	spare16;
    unsigned char	spare17;
    unsigned char	gcr;
};
volatile struct DMAREG *dma;

volatile unsigned char *ppi_cwr;	/* 8255 Rg[[hWX^ */
volatile unsigned char *opm_regno;	/* OPM WX^ԍݒ背WX^	*/
volatile unsigned char *opm_data;	/* OPM f[^WX^		*/
volatile unsigned char *adpcm_command;	/* ADPCM R}hWX^	*/
volatile unsigned char *adpcm_status;	/* ADPCM Xe[^XWX^	*/
volatile unsigned char *adpcm_data;	/* ADPCM f[^WX^		*/

#define BUFSIZE 0x400
unsigned char pcmbuf[BUFSIZE];


void create_adpcmdata();
void adpcm_outsel();
void adpcm_sample();
void adpcm_clksel();
void adpcm_stop();
void adpcm_start();
void dma_setup();
void dma_start();
void wait_complete();
void clear_flag();

int
main (int argc, char* argv[])
{
    unsigned int    pan, sample, clk;

    pan    = (argc >= 2) ? atoi (argv[1]) : 0;
    sample = (argc >= 3) ? atoi (argv[2]) : 0;
    clk    = (argc >= 4) ? atoi (argv[2]) : 0;

    _dos_super(0);
    dma		  = (struct DMAREG*)0xe840c0;
    ppi_cwr	  = (unsigned char*)0xe9a007;
    opm_regno	  = (unsigned char*)0xe90001;
    opm_data	  = (unsigned char*)0xe90003;
    adpcm_command = (unsigned char*)0xe92001;
    adpcm_status  = (unsigned char*)0xe92001;
    adpcm_data	  = (unsigned char*)0xe92003;

    adpcm_stop ();
    create_adpcmdata (pcmbuf, BUFSIZE);
    adpcm_outsel (pan);		/* Panpot Control */
    adpcm_sample (sample);	/* Sampling rate  */
    adpcm_clksel (clk);		/* ADPCM Clock	  */

    clear_flag ();
    dma_setup ();
    dma_start ();
    adpcm_start ();
    wait_complete ();
    adpcm_stop ();
    clear_flag ();

    return 0;
}

void
create_adpcmdata (unsigned char* buf, unsigned int length)
{
    while (length--)
	*buf++ = 0x1f;
}

void
adpcm_outsel (unsigned int sel)
{
    *ppi_cwr = (0 << 1) | ((sel >> 1) & 1);	/* Left  */
    *ppi_cwr = (1 << 1) | ((sel >> 0) & 1);	/* Right */
}

void
adpcm_sample (unsigned int rate)
{
    *ppi_cwr = (2 << 1) | ((rate >> 1) & 1);
    *ppi_cwr = (3 << 1) | ((rate >> 0) & 1);
}

void
adpcm_clksel (unsigned int sel)
{
    *opm_regno = 0x1b;
    *opm_data = (sel & 1) << 7;
}

void
adpcm_stop (void)
{
    *adpcm_command = 0x1;
}

void
adpcm_start (void)
{
    *adpcm_command = 0x2;
}


void
dma_setup (void)
{
    dma->dcr = 0x80;
    dma->ocr = 0x32;
    dma->scr = 0x04;
    dma->ccr = 0x00;
    dma->cpr = 0x08;
    dma->mfc = 0x05;
    dma->dfc = 0x05;

    dma->mtc = BUFSIZE;
    dma->mar = pcmbuf;
    dma->dar = (unsigned char *)adpcm_data;
}

void
dma_start (void)
{
    dma->ccr |= 0x80;
}

void
wait_complete (void)
{
    while (!(dma->csr & 0x90) && !(*adpcm_status & 0x80))
	;
}

void
clear_flag (void)
{
    dma->csr = 0xff;
}

/* EOF */
